Package: org.apache.groovy.xml.extensions

## [Java] Class XmlExtensions

- org.apache.groovy.xml.extensions.XmlExtensions

-     public class XmlExtensions
      extends Object

  This class defines all the new XML-related groovy methods which enhance the normal JDK XML classes when inside the Groovy environment. Static methods are used with the first parameter the destination class.

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `<T>` | `public static T` | `asType(Node self, Class<T> type)` Enables `node as Type` coercion for XML Nodes.
    `` | `public static Iterator<Node>` | `iterator(NodeList nodeList)` Makes NodeList iterable by returning a read-only Iterator which traverses over each Node.
    `` | `public static String` | `serialize(Element element)` Transforms the element to its text equivalent.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### <T> public static T asType(Node self, Class<T> type)

      Enables `node as Type` coercion for XML Nodes. Converts the Node to a Map via Node.toMap and then uses Groovy's standard Map coercion to produce the typed object. Does not require Jackson on the classpath.

      Parameters:
        `self` - the Node to convert
        `type` - the target type
      Type Parameters:
        `T` - the target type
      Returns:
        a typed object
      Since:
        6.0.0

    - #### public static Iterator<Node> iterator(NodeList nodeList)

      Makes NodeList iterable by returning a read-only Iterator which traverses over each Node.

      Parameters:
        `nodeList` - a NodeList
      Returns:
        an Iterator for a NodeList
      Since:
        1.0

    - #### public static String serialize(Element element)

      Transforms the element to its text equivalent. (The resulting string does not contain a xml declaration. Use `XmlUtil.serialize(element)` if you need the declaration.)

      Parameters:
        `element` - the element to serialize
      Returns:
        the string representation of the element
      Since:
        2.1